LVBM.AddOns.CThun = {
	["Name"] = "C'Thun",
	["Abbreviation1"] = "CThun",
	["Abbreviation2"] = "ct",
	["Version"] = "1.6",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Provides timers for tentacles and announces Dark Glare targets. Everyone except your 'main tank' (= the person who is the first to run in) should disable it.",
	["SlashCmdHelpText"] = {
		[1] = "/cthun start - starts the timers", 
	},
	["Instance"] = "Ahn'Qiraj",
	["Sort"] = 9,
	["Options"] = {
		["Enabled"] = false,
		["Announce"] = false,
	},
	["NextSpawn"] = "Claw",
	["CurrentTarget"] = "",
	["LastTarget"] = "",
	["LastTargetChange"] = GetTime(),
	["InCombat"] = false,
	["Events"] = {
		["CHAT_MSG_MONSTER_EMOTE"] = true,
		["PLAYER_REGEN_DISABLED"] = true,
		["CHAT_MSG_COMBAT_HOSTILE_DEATH"] = true,
	},
	["OnSlashCommand"] = function(msg)
		if string.lower(msg) == "start" then
			LVBM.AddOns.CThun.InCombat = true;
			LVBM.Schedule(44.5, "LVBM.AddOns.CThun.OnEvent", "DarkGlareWarning", 5);
			LVBM.Schedule(49.5, "LVBM.AddOns.CThun.OnEvent", "DarkGlareWarning", 0);
			LVBM.Schedule(39.5, "LVBM.AddOns.CThun.OnEvent", "SmallEyeWarning", 5);
			LVBM.Schedule(44.5, "LVBM.AddOns.CThun.OnEvent", "SmallEyeWarning", 0);
			if (not LVBM.GetStatusBarTimerTimeLeft("Dark Glare")) and LVBM.AddOns.CThun.Options.Announce then --synced timer is better!
				LVBM.StartStatusBarTimer(49.5, "Dark Glare")
			end
			if (not LVBM.GetStatusBarTimerTimeLeft("Eye Tentacles")) and LVBM.AddOns.CThun.Options.Announce then
				LVBM.StartStatusBarTimer(44.5, "Eye Tentacles")
			end
			LVBM.AddMsg("C'Thun timers started!", "C'Thun");
			return true;
		end
	end,
	["OnEvent"] = function(event, arg1)
		if (event == "PLAYER_REGEN_DISABLED") and (GetRealZoneText() == "Ahn'Qiraj") and (not LVBM.AddOns.CThun.InCombat) then
			if UnitClass("player") == LVBM_ROGUE or UnitClass("player") == LVBM_WARRIOR then
				return;
			end
			
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;  --to prevent unknown unit error
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Eye of C'Thun");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if UnitName("target") == "Eye of C'Thun" then
				LVBM.Schedule(1.5, "LVBM.AddOns.CThun.OnEvent", "ConfirmCombat");
			end
				
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif (event == "ConfirmCombat") then
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;  --to prevent unknown unit error
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Eye of C'Thun");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if (UnitName("target") == "Eye of C'Thun") and UnitAffectingCombat("target") then
				LVBM.AddOns.CThun.InCombat = true;
				LVBM.Schedule(43, "LVBM.AddOns.CThun.OnEvent", "DarkGlareWarning", 5);
				LVBM.Schedule(48, "LVBM.AddOns.CThun.OnEvent", "DarkGlareWarning", 0);
				LVBM.Schedule(38, "LVBM.AddOns.CThun.OnEvent", "SmallEyeWarning", 5);
				LVBM.Schedule(43, "LVBM.AddOns.CThun.OnEvent", "SmallEyeWarning", 0);
				if (not LVBM.GetStatusBarTimerTimeLeft("Dark Glare")) and LVBM.AddOns.CThun.Options.Announce then --synced timer is better!
					LVBM.StartStatusBarTimer(48, "Dark Glare")
				end
				if (not LVBM.GetStatusBarTimerTimeLeft("Eye Tentacles")) and LVBM.AddOns.CThun.Options.Announce then
					LVBM.StartStatusBarTimer(43, "Eye Tentacles")
				end
			end
			
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif (event == "ConfirmCombatEnd") then
			if (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) then
				LVBM.AddOns.CThun.InCombat = false;
				LVBM.UnSchedule("LVBM.AddOns.CThun.OnEvent");
				LVBM.EndStatusBarTimer("Eye Tentacles", true);
				LVBM.EndStatusBarTimer("Dark Glare", true);
				LVBM.EndStatusBarTimer("Dark Glare End", true);
				LVBM.EndStatusBarTimer("Giant Eye Tentacle", true);
				LVBM.EndStatusBarTimer("Giant Claw Tentacle", true);
			end
		elseif (event == "SmallEyeWarning") then
			if arg1 == 5 then
				LVBM.Announce("*** Eye Tentacles in 5 sec ***");
			elseif arg1 == 0 then
				LVBM.Schedule(40, "LVBM.AddOns.CThun.OnEvent", "SmallEyeWarning", 5);
				LVBM.Schedule(45, "LVBM.AddOns.CThun.OnEvent", "SmallEyeWarning", 0);
				if ((not LVBM.GetStatusBarTimerTimeLeft("Eye Tentacles")) or (LVBM.GetStatusBarTimerTimeLeft("Eye Tentacles") < 1.5)) and LVBM.AddOns.CThun.Options.Announce then
					LVBM.StartStatusBarTimer(45, "Eye Tentacles")
				end
			end
		elseif (event == "DarkGlareWarning") then
			if arg1 == 5 then
				LVBM.Announce("*** Dark Glare in 5 sec ***");
				LVBM.Schedule(1, "LVBM.AddOns.CThun.OnEvent", "CheckDarkGlareTarget");
			end		
		elseif (event == "CheckDarkGlareTarget") then
			if (LVBM.AddOns.CThun.CurrentTarget and (LVBM.AddOns.CThun.LastTargetChange + 4.5 > GetTime()))  then
				local name, subgroup, name2, subgroup2, iconCounter;
				iconCounter = 3;
				for i = 1, GetNumRaidMembers() do
					name, _, subgroup = GetRaidRosterInfo(i);
					if name == LVBM.AddOns.CThun.CurrentTarget then
						break;
					end
				end

				if (name and subgroup) then
					LVBM.Announce("*** Dark Glare on group "..subgroup.." ***");
					for i = 1, GetNumRaidMembers()do
						name2, _, subgroup2 = GetRaidRosterInfo(i);			
						if subgroup2 == subgroup then
							SetRaidTargetIcon("raid"..i, iconCounter);
							LVBM.Schedule(15, "LVBM.AddOns.CThun.OnEvent", "ResetRaidTargetIcon", name2);
							SendChatMessage("Dark Glare on you!", "WHISPER", this.language, name2);
							iconCounter = iconCounter + 1;
						end
					end	
				end
			end
			LVBM.Schedule(4, "LVBM.AddOns.CThun.OnEvent", "GetDarkGlareDuration");

		elseif (event == "GetDarkGlareDuration") then
			local delta = - GetTime() + LVBM.AddOns.CThun.LastTargetChange + 6.66; --timers by Mukka (AddOn: AQ_BossMod) - thx for this great idea to announce the targeted group :)
			if (delta < -1.5) or (delta > 1.8) then
				delta = 0;
				LVBM.AddMsg("Dark Glare timer adjustment failed.");
			end
			local glareEnd = 38 - 4 + delta + 3; -- +3 adjustment by me...Mukka's timers did not work 100% correct..."dark glare end" must be 3 seconds longer (and "dark glare" bar was 3 seconds too long --> wasn't a big problem)
			LVBM.Schedule((glareEnd - 5), "LVBM.AddOns.CThun.OnEvent", "DarkGlareEndWarning", 5);
			LVBM.Schedule(glareEnd, "LVBM.AddOns.CThun.OnEvent", "DarkGlareEndWarning", 0);
			if (not LVBM.GetStatusBarTimerTimeLeft("Dark Glare End")) and LVBM.AddOns.CThun.Options.Announce then
				LVBM.StartStatusBarTimer(glareEnd, "Dark Glare End");
			end		
		elseif (event == "DarkGlareEndWarning") then
			if arg1 == 5 then
				LVBM.Announce("*** Dark Glare ends in 5 sec ***");
			elseif arg1 == 0 then
				LVBM.Schedule(44.2, "LVBM.AddOns.CThun.OnEvent", "DarkGlareWarning", 5);
				if (not LVBM.GetStatusBarTimerTimeLeft("Dark Glare")) and LVBM.AddOns.CThun.Options.Announce then
					LVBM.StartStatusBarTimer(49, "Dark Glare");
				end
			end
		elseif (event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
			if (arg1 == "Eye of C'Thun dies.") then
				LVBM.UnSchedule("LVBM.AddOns.CThun.OnEvent");
				LVBM.EndStatusBarTimer("Dark Glare");
				LVBM.EndStatusBarTimer("Dark Glare End");
				LVBM.EndStatusBarTimer("Eye Tentacles");
				LVBM.Schedule(2, "LVBM.AddOns.CThun.OnEvent", "Phase2OrWeakenedEnd");
			end
		elseif (event == "Phase2OrWeakenedEnd") then
			LVBM.AddOns.CThun.NextSpawn = "Claw";
			LVBM.Announce("*** Giant Claw in 10 sec ***");
			LVBM.Schedule(10, "LVBM.AddOns.CThun.OnEvent", "GiantTentacleSpawn", 0);
			LVBM.StartStatusBarTimer(10, "Giant Claw Tentacle");
		elseif (event == "GiantTentacleSpawn") then
			if arg1 == 10 then
				LVBM.Announce("*** Giant "..LVBM.AddOns.CThun.NextSpawn.." and Eye Tentacles in 10 sec ***");
			elseif arg1 == 0 then
				if LVBM.AddOns.CThun.NextSpawn == "Claw" then
					LVBM.AddOns.CThun.NextSpawn = "Eye";
				elseif LVBM.AddOns.CThun.NextSpawn == "Eye" then
					LVBM.AddOns.CThun.NextSpawn = "Claw";
				end
				LVBM.Schedule(20, "LVBM.AddOns.CThun.OnEvent", "GiantTentacleSpawn", 10);
				LVBM.Schedule(30, "LVBM.AddOns.CThun.OnEvent", "GiantTentacleSpawn", 0);
				LVBM.StartStatusBarTimer(30, "Giant "..LVBM.AddOns.CThun.NextSpawn.." Tentacle");
				LVBM.StartStatusBarTimer(30, "Eye Tentacles");
			end
		elseif (event == "CHAT_MSG_MONSTER_EMOTE") then
			if arg1 == "is weakened!" and arg2 == "C'Thun" then
				LVBM.UnSchedule("LVBM.AddOns.CThun.OnEvent");
				LVBM.EndStatusBarTimer("Giant Claw Tentacle");
				LVBM.EndStatusBarTimer("Giant Eye Tentacle");
				LVBM.EndStatusBarTimer("Eye Tentacles");
				
				LVBM.Announce("*** C'Thun is weakened - 45 sec ***");
				LVBM.Schedule(20, "LVBM.AddOns.CThun.OnEvent", "WeakenedWarning", 25);
				LVBM.Schedule(35, "LVBM.AddOns.CThun.OnEvent", "WeakenedWarning", 10);
				LVBM.Schedule(45, "LVBM.AddOns.CThun.OnEvent", "Phase2OrWeakenedEnd", 0);
				LVBM.StartStatusBarTimer(45, "Weakened");
			end
		elseif (event == "WeakenedWarning") then
			if arg1 == 25 then
				LVBM.Announce("*** 25 sec left ***");
			elseif arg1 == 10 then
				LVBM.Announce("*** 10 sec left ***");
			end
		elseif (event == "ResetRaidTargetIcon") and arg1 then
			local name;
			for i = 1, GetNumRaidMembers() do
				name = GetRaidRosterInfo(i);
				if name == arg1 then
					SetRaidTargetIcon("raid"..i, 0);
					break;
				end
			end
		end
	end,

	["OnUpdate"] = function(elapsed)
		if (LVBM.AddOns.CThun.InCombat) and (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) and (not LVBM.GetScheduleTimeLeft("LVBM.AddOns.CThun.OnEvent", "ConfirmCombatEnd")) then
			LVBM.Schedule(7.5, "LVBM.AddOns.CThun.OnEvent", "ConfirmCombatEnd");
			return;
		end
	
		if (not LVBM.AddOns.CThun.InCombat) or (GetRealZoneText() ~= "Ahn'Qiraj") then		
			return;
		end
			
		local UnitID, newTarget;
			
		if UnitName("target") == "Eye of C'Thun" then
			newTarget = UnitName("targettarget")
		else
			for i = 1, GetNumRaidMembers() do
				if UnitName("raid"..i.."target") == "Eye of C'Thun" then
					newTarget = UnitName("Raid"..i.."targettarget")
					break;
				end
			end
		end
		if newTarget ~= LVBM.AddOns.CThun.LastTarget then
			if newTarget then
				if (LVBM.AddOns.CThun.LastTargetChange + 1 < GetTime()) then
					local targetIcon = 3;
					for i = 1, GetNumRaidMembers() do
						if GetRaidRosterInfo(i) == newTarget then
							if GetRaidTargetIndex("raid"..i) ~= 8 then
								SetRaidTargetIcon("raid"..i, 8);
							end
						end
					end
				end
				LVBM.AddOns.CThun.CurrentTarget = newTarget
				LVBM.AddOns.CThun.LastTarget = newTarget
				LVBM.AddOns.CThun.LastTargetChange = GetTime()
			else
				LVBM.AddOns.CThun.LastTarget = nil
			end
		end
	end,
	["UpdateInterval"] = 0.2,
};