if (GetLocale() == "enGB") or (GetLocale() == "enUS") then
	OURO_CAST_SWEEP = "Ouro begins to cast Sweep.";
	OURO_CAST_SAND_BLAST = "Ouro begins to perform Sand Blast.";
	OURO_DIRT_MOUND_QUAKE = "Dirt Mound's Quake";
	OURO_ENRAGE = "goes into a berserker rage!";
else
	OURO_CAST_SWEEP = "Ouro begins to cast Sweep.";
	OURO_CAST_SAND_BLAST = "Ouro begins to perform Sand Blast.";
	OURO_DIRT_MOUND_QUAKE = "Dirt Mound's Quake";
	OURO_ENRAGE = "goes into a berserker rage!";
end	
	
LVBM.AddOns.Ouro = {
	["Name"] = "Ouro",
	["Abbreviation1"] = "ouru",
	["Version"] = "1.1",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Provides a timer for Ouros submerge.",
	["Instance"] = "Ahn'Qiraj",
	["Sort"] = 8,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
	},	
	["Events"] = {
		["CHAT_MSG_MONSTER_EMOTE"] = true,
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"] = true,
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF"] = true,
		["PLAYER_REGEN_DISABLED"] = true,
	},
	["Submerged"] = false,
	["Enraged"] = false,
	["InCombat"] = false,
	["OnEvent"] = function(event, arg1)
		if (event == "PLAYER_REGEN_DISABLED") and (GetRealZoneText() == "Ahn'Qiraj") and (not LVBM.AddOns.Ouro.InCombat) then
			if UnitClass("player") == LVBM_ROGUE or UnitClass("player") == LVBM_WARRIOR then
				return;
			end
			
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent; 
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Ouro");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if UnitName("target") == "Ouro" then
				LVBM.Schedule(15, "LVBM.AddOns.Ouro.OnEvent", "ConfirmCombat");
			end
				
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif (event == "ConfirmCombat") then
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Ouro");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if (UnitName("target") == "Ouro") and UnitAffectingCombat("target") then
				LVBM.AddOns.Ouro.InCombat = true;
				LVBM.AddOns.Ouro.Enraged = false;
				LVBM.Announce("*** Ouro has emerged - 3 minutes until submerge ***");
				LVBM.Schedule(65, "LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 100);
				LVBM.Schedule(105, "LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 60);
				LVBM.Schedule(150, "LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 15);
				LVBM.StartStatusBarTimer(165, "Submerge");
			end
			
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif (event == "ConfirmCombatEnd") then
			if (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) then
				LVBM.AddOns.Ouro.InCombat = false;
				LVBM.AddOns.Ouro.Enraged = false;
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent");
				LVBM.EndStatusBarTimer("Submerge", true);
				LVBM.EndStatusBarTimer("Emerge", true);
				LVBM.EndStatusBarTimer("Sweep", true);
				LVBM.EndStatusBarTimer("Sand Blast", true);
			end
		elseif (event == "CHAT_MSG_MONSTER_EMOTE") then
			if arg1 == OURO_ENRAGE and arg2 == "Ouro" then
				LVBM.Announce("*** Enrage ***");
				LVBM.AddOns.Ouro.Enraged = true;
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 100); --ouro does not submerge when enraged
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 60);
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 15);
				LVBM.EndStatusBarTimer("Submerge");
			end
		elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE") or (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF") then
			if (arg1 == OURO_CAST_SWEEP) then
				LVBM.Announce("*** Sweep inc - 1.5 sec ***");
				LVBM.Schedule(16, "LVBM.AddOns.Ouro.OnEvent", "SweepWarning", 5);
				LVBM.EndStatusBarTimer("Sweep")
				LVBM.StartStatusBarTimer(1.5, "Sweep Cast");
				LVBM.Schedule(1.5, "LVBM.StartStatusBarTimer", 19, "Sweep");
			elseif (arg1 == OURO_CAST_SAND_BLAST) then
				LVBM.Announce("*** Sand Blast inc - 2 sec ***");				
				LVBM.Schedule(18, "LVBM.AddOns.Ouro.OnEvent", "SandBlastWarning", 5);
				LVBM.EndStatusBarTimer("Sand Blast");
				LVBM.StartStatusBarTimer(2, "Sand Blast Cast");
				LVBM.Schedule(2, "LVBM.StartStatusBarTimer", 21, "Sand Blast");
			elseif (not LVBM.AddOns.Ouro.Submerged) and (not LVBM.AddOns.Ouro.Enraged) and string.find(arg1, OURO_DIRT_MOUND_QUAKE) then
				LVBM.AddOns.Ouro.Submerged = true;
				LVBM.Announce("*** Ouro submerged 30 sec ***");
				LVBM.Schedule(22, "LVBM.AddOns.Ouro.OnEvent", "EmergeWarning", 5);
				LVBM.Schedule(27, "LVBM.AddOns.Ouro.OnEvent", "OuroEmerge");
				LVBM.Schedule(34, "LVBM.AddOns.Ouro.OnEvent", "ResetSubmergeVar");
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 100);
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 60);
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 15);
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SandBlastWarning", 5);
				LVBM.UnSchedule("LVBM.AddOns.Ouro.OnEvent", "SweepWarning", 5);
				LVBM.EndStatusBarTimer("Submerge");
				LVBM.EndStatusBarTimer("Sweep");
				LVBM.EndStatusBarTimer("Sand Blast");
				LVBM.StartStatusBarTimer(27, "Emerge");
			end
		elseif (event == "ResetSubmergeVar") then
			LVBM.AddOns.Ouro.Submerged = false;
		elseif (event == "SweepWarning") then		
			if arg1 == 5 then
				LVBM.Announce("*** Sweep in ~5 sec ***");
			end
		elseif (event == "SandBlastWarning") then
			if arg1 == 5 then
				LVBM.Announce("*** Sand Blast in ~5 sec ***");
			end
		elseif (event == "EmergeWarning") then
			LVBM.Announce("*** ~5 seconds until Ouro emerges ***");
		elseif (event == "OuroEmerge") then
			LVBM.Announce("*** Ouro has emerged - 3 minutes until submerge ***");
			LVBM.Schedule(80, "LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 100);
			LVBM.Schedule(120, "LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 60);
			LVBM.Schedule(165, "LVBM.AddOns.Ouro.OnEvent", "SubmergeWarning", 15);
			LVBM.StartStatusBarTimer(180, "Submerge");
		elseif (event == "SubmergeWarning") then
			if arg1 == 100 then					
				LVBM.Announce("*** Possible submerge in 10 seconds ***");
			elseif arg1 == 60 then				
				LVBM.Announce("*** 60 seconds until Ouro submerges ***");
			elseif arg1 == 15 then
				LVBM.Announce("*** 15 seconds until Ouro submerges ***");
			end
		end
	end,
	
	["OnUpdate"] = function(elapsed)
		if (LVBM.AddOns.Ouro.InCombat) and (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) and (not LVBM.GetScheduleTimeLeft("LVBM.AddOns.Ouro.OnEvent", "ConfirmCombatEnd")) then
			LVBM.Schedule(10, "LVBM.AddOns.Ouro.OnEvent", "ConfirmCombatEnd");
			return;
		end
	end,
	["UpdateInterval"] = 3,
};