if (GetLocale() == "enGB") or (GetLocale() == "enUS") then
	TWINS_CAST_SPELL_1 = "Emperor Vek'lor casts Twin Teleport.";
	TWINS_CAST_SPELL_2 = "Emperor Vek'nilash casts Twin Teleport.";
end

LVBM.AddOns.TwinEmps = {
	["Name"] = "Twin Emperors",
	["Abbreviation1"] = "twins",
	["Abbreviation2"] = "twinemp",
	["Abbreviation3"] = "twin",
	["Version"] = "1.0",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Provides timers for the Twin Emperors encounter.",
	["Instance"] = "Ahn'Qiraj",
	["Sort"] = 6,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
	},	
	["Events"] = {
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS"] = true,
		["PLAYER_REGEN_DISABLED"] = true,
	},
	
	["OnEvent"] = function(event, arg1)	
		if event == "PLAYER_REGEN_DISABLED" and GetRealZoneText() == "Ahn'Qiraj" then
			if UnitClass("player") == LVBM_ROGUE or UnitClass("player") == LVBM_WARRIOR then
				return;
			end
				
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;  --to prevent unknown unit error
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Emperor Vek");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if (UnitName("target") == "Emperor Vek'nilash") or (UnitName("target") == "Emperor Vek'lor") then
				LVBM.Schedule(2, "LVBM.AddOns.TwinEmps.OnEvent", "ConfirmCombat");
			end
				
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "ConfirmCombat" then		
			if UnitClass("player") == "Rogue" then
				return;
			end
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;  --to prevent unknown unit error
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Emperor Vek");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
			
			if ((UnitName("target") == "Emperor Vek'nilash") or (UnitName("target") == "Emperor Vek'lor")) and UnitAffectingCombat("target") then
				LVBM.Schedule(298, "LVBM.AddOns.TwinEmps.OnEvent", "EnrageWarning", 10)
				LVBM.Schedule(598, "LVBM.AddOns.TwinEmps.OnEvent", "EnrageWarning", 5)
				LVBM.Schedule(838, "LVBM.AddOns.TwinEmps.OnEvent", "EnrageWarning", 1)
				LVBM.Schedule(868, "LVBM.AddOns.TwinEmps.OnEvent", "EnrageWarning", 0.5)
				LVBM.StartStatusBarTimer(898, "Enrage");
				
				LVBM.StartStatusBarTimer(28, "Teleport");
				LVBM.Schedule(18, "LVBM.AddOns.TwinEmps.OnEvent", "TeleportWarning", 10);
				LVBM.Schedule(23, "LVBM.AddOns.TwinEmps.OnEvent", "TeleportWarning", 5);
			end
			
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end		
		elseif event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" then -- mob casts a spell
			if (arg1 == TWINS_CAST_SPELL_1) or (arg1 == TWINS_CAST_SPELL_2) then
				LVBM.Announce("*** Teleport ***");
				LVBM.StartStatusBarTimer(30, "Teleport");
				LVBM.Schedule(20, "LVBM.AddOns.TwinEmps.OnEvent", "TeleportWarning", 10);
				LVBM.Schedule(25, "LVBM.AddOns.TwinEmps.OnEvent", "TeleportWarning", 5);
			end
		elseif event == "TeleportWarning" then
			if arg1 == 10 then
				LVBM.Announce("*** Teleport in 10 sec ***");
			elseif arg1 == 5 then
				LVBM.Announce("*** Teleport in 5 sec ***");
			end
		elseif event == "EnrageWarning" then
			if arg1 == 10 then
				LVBM.Announce("*** Enrage in 10 min ***");
			elseif arg1 == 5 then
				LVBM.Announce("*** Enrage in 5 min ***");
			elseif arg1 == 1 then
				LVBM.Announce("*** Enrage in 1 min ***");
			elseif arg1 == 0.5 then
				LVBM.Announce("*** Enrage in 30 sec ***");
			end
		end
	end,
};