LVBM.AddOns.Chromaggus = {
	["Name"] = "Chromaggus",
	["Abbreviation1"] = "chrom",
	["Version"] = "1.1",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Provides timers for his breaths and announces the vulnerability.",
	["Instance"] = "Blackwing Lair",
	["Sort"] = 7,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
		["Frenzy"] = true,
		["Vulnerability"] = true,
	},
	["Breath1"] = "Breath 1",
	["Breath2"] = "Breath 2",
	["Vulnerability"] = "",
	["InCombat"] = false,
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.Chromaggus.Options.Frenzy",
			["text"] = "Announce Frenzy",
			["func"] = function() LVBM.AddOns.Chromaggus.Options.Frenzy = not LVBM.AddOns.Chromaggus.Options.Frenzy; end,
		},
		[2] = {
			["variable"] = "LVBM.AddOns.Chromaggus.Options.Vulnerability",
			["text"] = "Announce Vulnerability",
			["func"] = function() LVBM.AddOns.Chromaggus.Options.Vulnerability = not LVBM.AddOns.Chromaggus.Options.Vulnerability; end,
		},
	},
	["Events"] = {
		["PLAYER_REGEN_DISABLED"] = true,
		["CHAT_MSG_MONSTER_EMOTE"] = true,
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"] = true,
		["CHAT_MSG_SPELL_SELF_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PARTY_DAMAGE"] = true,
		["CHAT_MSG_SPELL_FRIENDLYPLAYER_DAMAGE"] = true,
	},
	["OnEvent"] = function(event, arg1)
		if event == "PLAYER_REGEN_DISABLED" and GetRealZoneText() == "Blackwing Lair" then
			if UnitClass("player") == LVBM_ROGUE or UnitClass("player") == LVBM_WARRIOR then
				return;
			end
				
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Chromaggus");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if UnitName("target") == "Chromaggus" then
				LVBM.Schedule(6, "LVBM.AddOns.Chromaggus.OnEvent", "ConfirmCombat");
			end
				
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "ConfirmCombat" then		
			if UnitClass("player") == "Rogue" then
				return;
			end
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent; 
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Chromaggus");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
			
			if (UnitName("target")) == "Chromaggus" and UnitAffectingCombat("target") then			
				LVBM.Schedule(16, "LVBM.AddOns.Chromaggus.OnEvent", "BreathWarning", 1);
				LVBM.Schedule(48, "LVBM.AddOns.Chromaggus.OnEvent", "BreathWarning", 2);
				LVBM.StartStatusBarTimer(24, "Breath 1");
				LVBM.StartStatusBarTimer(54, "Breath 2");
				LVBM.AddOns.Chromaggus.InCombat = true;
			end
			
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" and arg1 then
			local breath;
			_, _, breath = string.find(arg1, "Chromaggus begins to cast ([%w%s]+)");
			if breath then
				if LVBM.AddOns.Chromaggus.Breath1 == "Breath 1" then
					LVBM.AddOns.Chromaggus.Breath1 = breath;
				elseif LVBM.AddOns.Chromaggus.Breath2 == "Breath 2" then
					LVBM.AddOns.Chromaggus.Breath2 = breath;
				end
				
				LVBM.Announce("*** Chromaggus begins to cast "..breath.." ***");
				
				LVBM.StartStatusBarTimer(2, breath.." Cast");
				LVBM.Schedule(2, "LVBM.AddOns.Chromaggus.OnEvent", "StartNewBreathTimer", breath);
			end
		elseif event == "StartNewBreathTimer" and arg1 then
			LVBM.EndStatusBarTimer(tostring(arg1));
			LVBM.StartStatusBarTimer(60, tostring(arg1));
			if arg1 == LVBM.AddOns.Chromaggus.Breath1 then
				LVBM.Schedule(50, "LVBM.AddOns.Chromaggus.OnEvent", "BreathWarning", 1);
			elseif arg1 == LVBM.AddOns.Chromaggus.Breath2 then
				LVBM.Schedule(50, "LVBM.AddOns.Chromaggus.OnEvent", "BreathWarning", 2);
			end
		elseif event == "BreathWarning" then
			if arg1 then
				LVBM.Announce("*** "..LVBM.AddOns.Chromaggus['Breath'..tostring(arg1)].." in 10 sec ***");
			end
		elseif event == "CHAT_MSG_SPELL_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_FRIENDLYPLAYER_DAMAGE" then		
			if LVBM.AddOns.Chromaggus.Options.Vulnerability and LVBM.AddOns.Chromaggus.Vulnerability == "" then
				local hitcrit, damage, damagetype;
				_, _, hitcrit, damage, damagetype = string.find(arg1, "[^%s]+ [^%s]+ (%w+) Chromaggus for (%d+) ([^%s]+) damage");
				
				if (hitcrit == "hits" or hitcrit == "crits") and tonumber(damage) and damagetype then			
					if (hitcrit == "hits" and tonumber(damage) >= 666) or (hitcrit == "crits" and tonumber(damage) >= 1337) then
						LVBM.AddOns.Chromaggus.Vulnerability = damagetype;
						LVBM.Announce("*** New vulnerability: "..damagetype.." ***");
					end
				end
			end
		elseif event == "CHAT_MSG_MONSTER_EMOTE" then
			if arg1 == "goes into a killing frenzy!" and arg2 == "Chromaggus" then
				if LVBM.AddOns.Chromaggus.Options.Frenzy then
					LVBM.Announce("*** Fenzy ***");
				end
			elseif arg1 == "flinches as its skin shimmers." and arg2 == "Chromaggus" then
				if LVBM.AddOns.Chromaggus.Options.Vulnerability then
					LVBM.Announce("*** Vulnerability changed ***");
					LVBM.Schedule(3, "LVBM.AddOns.Chromaggus.OnEvent", "ClearVulnerability");
				end
			end
		elseif event == "ClearVulnerability" then
			LVBM.AddOns.Chromaggus.Vulnerability = "";
		elseif event == "ConfirmCombatEnd" then
			if (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) then
				LVBM.UnSchedule("LVBM.AddOns.Chromaggus.OnEvent");
				LVBM.EndStatusBarTimer(LVBM.AddOns.Chromaggus.Breath1, true);
				LVBM.EndStatusBarTimer(LVBM.AddOns.Chromaggus.Breath2, true);
				LVBM.AddOns.Chromaggus.InCombat = false;
				LVBM.AddOns.Chromaggus.Breath1 = "Breath 1";
				LVBM.AddOns.Chromaggus.Breath2 = "Breath 2";
				LVBM.AddOns.Chromaggus.Vulnerability = "";
			end
		end
	end,

	["OnUpdate"] = function(elapsed) 
		if (LVBM.AddOns.Chromaggus.InCombat) and (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) and (not LVBM.GetScheduleTimeLeft("LVBM.AddOns.Chromaggus.OnEvent", "ConfirmCombatEnd")) then
			LVBM.Schedule(10, "LVBM.AddOns.Chromaggus.OnEvent", "ConfirmCombatEnd");
		end
	end,
	["UpdateInterval"] = 3,
};