LVBM.AddOns.Ebonroc = {
	["Name"] = "Ebonroc",
	["Abbreviation1"] = "ebon",
	["Version"] = "1.0",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Provides a timer for Wing Buffet and announces Shadow of Ebonroc.",
	["Instance"] = "Blackwing Lair",
	["Sort"] = 5,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
	},
	["Events"] = {
		["CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"] = true,
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"] = true,
		["CHAT_MSG_SPELL_AURA_GONE_OTHER"] = true,
		["CHAT_MSG_SPELL_AURA_GONE_SELF"] = true,
	},	
		
	["OnEvent"] = function(event, arg1)
		if event == "PLAYER_REGEN_DISABLED" and GetRealZoneText() == "Blackwing Lair" then
			if UnitClass("player") == LVBM_ROGUE or UnitClass("player") == LVBM_WARRIOR then
				return;
			end
				
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Ebonroc");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if UnitName("target") == "Ebonroc" then
				LVBM.Schedule(10, "LVBM.AddOns.Ebonroc.OnEvent", "ConfirmCombat");
			end
				
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "ConfirmCombat" then		
			if UnitClass("player") == "Rogue" then
				return;
			end
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Ebonroc");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
			
			if (UnitName("target")) == "Ebonroc" and UnitAffectingCombat("target") then				
				LVBM.StartStatusBarTimer(21, "Wing Buffet");
				LVBM.Schedule(18, "LVBM.AddOns.Ebonroc.OnEvent", "WingBuffetWarning", 3);
			end
			
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" then
			if arg1 == "Ebonroc begins to cast Wing Buffet." then
				LVBM.Announce("*** Ebonroc begins to cast Wing Buffet ***");
				LVBM.StartStatusBarTimer(1, "Wing Buffet Cast");
				LVBM.Schedule(29, "LVBM.AddOns.Ebonroc.OnEvent", "WingBuffetWarning", 3);
				LVBM.Schedule(1, "LVBM.AddOns.Ebonroc.OnEvent", "WingBuffetWarning", 31);
			elseif arg1 == "Ebonroc begins to cast Shadow Flame." then
				LVBM.Announce("*** Shadow Flame in 2 sec ***");
				LVBM.StartStatusBarTimer(2, "Shadow Flame Cast");
			end
			
		elseif event == "WingBuffetWarning" then
			if arg1 == 3 then
				LVBM.Announce("*** Wing Buffet in 3 sec ***");
			elseif arg1 == 31 then
				LVBM.EndStatusBarTimer("Wing Buffet");
				LVBM.StartStatusBarTimer(31, "Wing Buffet");
			end
			
		elseif event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" then
			local _, _, name = string.find(arg1, "([^%s]+) ([^%s]+) afflicted by Shadow of Ebonroc");
			if name == "You" then
				name = UnitName("player");
			end		
			
			if name then
				local targetID, promoted;
				for i = 1, GetNumRaidMembers() do
					if UnitName("raid"..i) == UnitName("player") then
						_, promoted = GetRaidRosterInfo(i);
					end
					if UnitName("raid"..i) == name then
						targetID = i;
					end
				end
				if targetID and promoted >= 1 then
					if GetRaidTargetIndex("raid"..targetID) ~= 8 then
						SetRaidTargetIcon("raid"..targetID, 8);
					end
				end	
					
				LVBM.Announce("*** "..name.." has Shadow of Ebonroc ***");
			end
		elseif ((event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") or (event == "CHAT_MSG_SPELL_AURA_GONE_SELF")) and arg1 then
			local name;
			_, _, name = string.find(arg1, "Shadow of Ebonroc fades from (%w+)");
			if Name then
				local targetID, promoted;
				for i = 1, GetNumRaidMembers() do
					if UnitName("raid"..i) == UnitName("player") then
						_, promoted = GetRaidRosterInfo(i);
					end
					if UnitName("raid"..i) == name then
						targetID = i;
					end
				end	
				if targetID and promoted >= 1 then
					if GetRaidTargetIndex("raid"..targetID) == 8 then
						SetRaidTargetIcon("raid"..targetID, 0);
					end
				end	
			end
		end
	end,
};