LVBM.AddOns.Firemaw = {
	["Name"] = "Firemaw",
	["Version"] = "1.0",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Provides a timer for Wing Buffet.",
	["Instance"] = "Blackwing Lair",
	["Sort"] = 4,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
	},
	["Events"] = {
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"] = true,
	},	
		
	["OnEvent"] = function(event, arg1)
		if event == "PLAYER_REGEN_DISABLED" and GetRealZoneText() == "Blackwing Lair" then
			if UnitClass("player") == LVBM_ROGUE or UnitClass("player") == LVBM_WARRIOR then
				return;
			end
				
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Firemaw");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if UnitName("target") == "Firemaw" then
				LVBM.Schedule(10, "LVBM.AddOns.Firemaw.OnEvent", "ConfirmCombat");
			end
				
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "ConfirmCombat" then		
			if UnitClass("player") == "Rogue" then
				return;
			end
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;  --to prevent unknown unit error
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Firemaw");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
			
			if (UnitName("target")) == "Firemaw" and UnitAffectingCombat("target") then				
				LVBM.StartStatusBarTimer(21, "Wing Buffet");
				LVBM.Schedule(18, "LVBM.AddOns.Firemaw.OnEvent", "WingBuffetWarning", 3);
			end
			
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" then
			if arg1 == "Firemaw begins to cast Wing Buffet." then
				LVBM.Announce("*** Firemaw begins to cast Wing Buffet ***");
				LVBM.StartStatusBarTimer(1, "Wing Buffet Cast");
				LVBM.Schedule(29, "LVBM.AddOns.Firemaw.OnEvent", "WingBuffetWarning", 3);
				LVBM.Schedule(1, "LVBM.AddOns.Firemaw.OnEvent", "WingBuffetWarning", 31);
			elseif arg1 == "Firemaw begins to cast Shadow Flame." then
				LVBM.Announce("*** Shadow Flame in 2 sec ***");
				LVBM.StartStatusBarTimer(2, "Shadow Flame Cast");
			end
		elseif event == "WingBuffetWarning" then
			if arg1 == 3 then
				LVBM.Announce("*** Wing Buffet in 3 sec ***");
			elseif arg1 == 31 then
				LVBM.EndStatusBarTimer("Wing Buffet");
				LVBM.StartStatusBarTimer(31, "Wing Buffet");
			end
		end
	end,
};