--  La Vendetta Boss Mods AddOn by La Vendetta|Tandanu @ EU-Azshara. GUI by La Vendetta|Nitram.
--  http://www.deadlyminds.net


-----------------------
--  Timer Functions  --
-----------------------

--  LVBM.Schedule(Delay, NameOrFunction[, Argument1, Argument2]);
--  Delay must be a number. NameOfFunction must be a string or a function. Argument1 & 2 can be strings, numbers, tables, functions etc.
--  Example: LVBM.Schedule(10, "SendChatMessage", "lol", "GUILD"); will write "lol" after 10 sec
--
--  LVBM.UnSchedule(NameOrFunction[, Argument1, Argument2]);
--  If you only specify the name of the function, all scheduled tasks which call this function will be deleted.
--  Example: LVBM.UnSchedule("SendChatMessage", "lol", "GUILD"); will delete the scheduled task of the example above.
--           LVBM.UnSchedule("SendChatMessage"); will delete all scheduled tasks which call SendChatMessage
--
--  timeLeft, timeElapsed = LVBM.GetScheduleTimeLeft(NameOrFunction[, Argument1, Argument2]);
--	Returns the time left until the scheduled function is executed and the time elapsed.
--  Example: timeLeft, timeElapsed = LVBM.GetSchedule("SendChatMessage", "lol", "GUILD")
--  timeLeft will be 9 and timeElapsed will be 1, if you call this function 1 second after the LVBM.Schedule example above
--
--  isScheduled = LVBM.FunctionIsScheduled(func)
--  Returns true if a given function is scheduled to be called
--
--  LVBM.StartTimer("name");
--  Starts a timer.
--
--  elapsed = LVBM.GetTimer("name");
--  Returns the elapsed time since LVBM.StartTimer
--
--  elapsed = LVBM.StopTimer("name");
--  Stops the timer and returns the elapsed time
--
--  elapsed = LVBM.ResumeTimer("name");
--  Resumes a stopped timer and returns the elapsed time
--
--  elapsed = LVBM.EndTimer("name");
--  Deletes a timer and returns the elapsed time
--
--  LVBM.StartStatusBarTimer(timer, "text");
--  Adds a status bar timer :)
--
--  timeLeft, timeElapsed = LVBM.GetStatusBarTimerTimeLeft("text");
--	Returns the time left and the time elapsed of the status bar with the text "text"
--
--  LVBM.EndStatusBarTimer("text");
--  Removes the status bar timer with the text "text"


-------------------------
--  Message Functions  --
-------------------------

--  LVBM.AddMsg("message"[, "addon"]);
--  Prints a message in the default chat frame, "addon" is used as prefix...if not set, the boss mod which called the function will be detected automatically and used as prefix
--  Example: LVBM.AddMsg("zomg!");
--
--  LVBM.Announce("message");
--  Announces a message to the raid, using Blizzard's "Raid Warning" chat
--  Example: LVBM.Announce("*** Locust Swarm in 3 sec ***");


BINDING_HEADER_LVBM = "La Vendetta Boss Mods";
BINDING_NAME_TOGGLE = "Toggle GUI";

LVBM_SavedVars = {
	["AddOns"] = {
	},
	["LVBM"] = {
	},
}

LVBM = {}

LVBM.Version = "1.41";

LVBM.ScheduleData = {
}

LVBM.TimerData = {
}

LVBM.StatusBarData = {
}

LVBM.Hooks = {
}

LVBM.SpamProtection ={
}

LVBM.InRaid = false;

LVBM.SyncInfo = {
	["Clients"] = {},
}

LVBM.AddOns = {	
}

LVBM.SortedAddOns = { --table.sort sucks...
}

LVBM.Options = {
	["StatusBarColor"] = {
		["r"] = 1.0,
		["g"] = 0.7,
		["b"] = 0.0,
		["a"] = 1.0,
	},
	["StatusBarsFlippedOver"] = false,
	["FillUpStatusBars"] = true,
	["EnableStatusBars"] = true,
	["EnableSync"] = true,	
	["Channel"] = "",
	["MinimapButton"] = {
		["Position"] = 225,
		["Radius"] = 78.1,
		["Enabled"] = true,
	},	
}

---------------------
--OnEvent Functions--
---------------------
function LVBM.OnLoad()
	SLASH_LVNAXXRAMASBOSSMODS1 = "/vendetta";
	SLASH_LVNAXXRAMASBOSSMODS2 = "/lv";
	SLASH_LVNAXXRAMASBOSSMODS3 = "/bossmods";
	SLASH_LVNAXXRAMASBOSSMODS4 = "/bm";
	SLASH_LVNAXXRAMASBOSSMODS5 = "/lvbm";
	SLASH_LVNAXXRAMASBOSSMODS6 = "/lvbossmods";
	SlashCmdList["LVNAXXRAMASBOSSMODS"] = function(msg)
		if string.lower(msg) == "unlock" then
			LVBM_StatusBarTimerDrag:Show();
		elseif string.lower(msg) == "lock" then
			LVBM_StatusBarTimerDrag:Hide();
		elseif string.lower(msg) == "bc" or string.lower(msg) == "broadcast" or string.lower(msg) == "brotkasten" then
			LVBM.BroadcastSyncChannel();
		elseif string.lower(msg) == "ver" or string.lower(msg) == "version" then
			local syncInfo = {}
			for index, value in LVBM.SyncInfo.Clients do
				if type(index) == "string" and type(value) == "string" and tonumber(value) then
					table.insert(syncInfo, {["Name"] = index, ["Version"] = value});
				end
			end
			
			table.sort(syncInfo, function(v1, v2) return tonumber(v1.Version) > tonumber(v2.Version); end); --I hate table.sort
			for index, value in syncInfo do
				LVBM.AddMsg(value.Name..": "..value.Version);
			end
		elseif string.lower(msg) == "bars" or string.lower(msg) == "barinfo" or string.lower(msg) == "syncedby" or string.lower(msg) == "syncinfo" then
			local syncedBars = false;
			for index, value in LVBM.StatusBarData do
				if value.syncedBy then
					LVBM.AddMsg(index..": "..value.syncedBy);
					syncedBars = true;
				end
			end
			if( syncedBars == false ) then
				LVBM.AddMsg(LVBMGUI_SYNCBUTTONGETNOSYNCINFO);
			end
		else
			if LVBMBossModFrame:IsShown() then
				HideUIPanel(LVBMBossModFrame);			
			else
				ShowUIPanel(LVBMBossModFrame);
			end
		end
	end

	LVBM_API:RegisterEvent("VARIABLES_LOADED");
	LVBM_API:RegisterEvent("PLAYER_LEAVING_WORLD");
	LVBM_API:RegisterEvent("CHAT_MSG_CHANNEL");
	LVBM_API:RegisterEvent("CHAT_MSG_RAID");
	LVBM_API:RegisterEvent("CHAT_MSG_RAID_LEADER");
	LVBM_API:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");
	LVBM_API:RegisterEvent("CHAT_MSG_CHANNEL_LEAVE");
	LVBM_API:RegisterEvent("RAID_ROSTER_UPDATE");
end


function LVBM.OnVarsLoaded()
	local loadedAddOns = {};
	LVBM.Register();	

	LVBM.AddMsg("La Vendetta Boss Mods v"..LVBM.Version.." by La Vendetta|Tandanu and La Vendetta|Nitram @ EU-Azshara loaded.");
	
	if not LVBM_SavedVars.LVBM then --if we update from v0.5 or lower, we dont have this field...
		LVBM_SavedVars.LVBM = {} --...so we have to create it
	end
	
	for index, value in LVBM.Options do --load saved vars
		if LVBM_SavedVars.LVBM[index] == nil then
			LVBM_SavedVars.LVBM[index] = value
		else
			LVBM.Options[index] = LVBM_SavedVars.LVBM[index];
		end
	end
	
	if CT_RA_Channel then
		LVBM.Options.Channel = CT_RA_Channel;
	end	

	LVBMMinimapButton_Move();
	LVBMStatusBars_FlipOver();
	if not LVBM.Options.MinimapButton.Enabled then
		LVBMMinimapButton:Hide();
	else
		LVBMMinimapButton:Show();
	end

	for i = 1, 10 do
		getglobal("LVBM_StatusBarTimer"..i):SetStatusBarColor(LVBM.Options.StatusBarColor.r, LVBM.Options.StatusBarColor.g, LVBM.Options.StatusBarColor.b, LVBM.Options.StatusBarColor.a);
	end
	LVBM_StatusBarTimerDrag:SetStatusBarColor(LVBM.Options.StatusBarColor.r, LVBM.Options.StatusBarColor.g, LVBM.Options.StatusBarColor.b, LVBM.Options.StatusBarColor.a);
	
	if GetNumRaidMembers() > 1 and GetChannelName(LVBM.Options.Channel) then
		LVBM.AddSyncMessage("REQ VER", true);
	end
	if GetNumRaidMembers() > 1 then
		LVBM.InRaid = true;
	end
	
	for index, value in LVBM.AddOns do	--load AddOn's saved variables/add new addons to the LVBM_SavedVars table/set default values for missing fields		
		if not value.Name then
			LVBM.AddOns[index].Name = index;
		end
		if not value.Version then
			LVBM.AddOns[index].Version = "1.0";
		end
		if not value.Author then
			LVBM.AddOns[index].Author = "Unknown";
		end
		if not value.Description then
			LVBM.AddOns[index].Description = "Description unavailable.";
		end
		if not value.Instance then
			LVBM.AddOns[index].Instance = "Ahn'Qiraj";
		end
		if (value.Instance ~= "Ahn'Qiraj") and (value.Instance ~= "Naxxramas") and (value.Instance ~= "Blackwing Lair") then
			LVBM.AddOns[index].Instance = "Blackwing Lair";
		end
		if not value.Sort then
			value.Sort = 9999;
		end
		if not value.Options then
			LVBM.AddOns[index].Options = {
				["Enabled"] = true,
				["Announce"] = false,
			}
		end		
		if value.Options.Enabled == nil then --not value.Options.Enabled would return true if the AddOn is disabled....and the next line would enable the addon
			LVBM.AddOns[index].Options.Enabled = true;
		end
		if not value.Events then
			LVBM.AddOns[index].Events = {};
		end
		if type(value.OnLoad) ~= "function" then
			LVBM.AddOns[index].OnLoad = function() end;
		end
		if type(value.OnEvent) ~= "function" then
			LVBM.AddOns[index].OnEvent = function() end;
		end
		if not value.UpdateInterval then
			LVBM.AddOns[index].UpdateInterval = 0;
		end
		if not value.elapsed then
			LVBM.AddOns[index].elapsed = 0;
		end

		if LVBM_SavedVars.AddOns[index] == nil then --load saved vars
			LVBM_SavedVars.AddOns[index] = value.Options
		else
			for index2, value2 in value.Options do				
				if LVBM_SavedVars.AddOns[index][index2] == nil then					
					LVBM_SavedVars.AddOns[index][index2] = value2;
				else
					LVBM.AddOns[index].Options[index2] = LVBM_SavedVars.AddOns[index][index2];
				end
			end
		end
				
		setglobal("SLASH_"..index.."1", "/"..string.gsub(value.Name, " ", "")); --register slash commands
		for i = 1, 10 do
			if value["Abbreviation"..i] then
				setglobal("SLASH_"..index..(i+1), "/"..value["Abbreviation"..i]);
			else
				break;
			end
		end

		loadstring("SlashCmdList["..string.format('%q', index).."] = function(msg) "..
			"local abbrString = ''; "..
			"if string.lower(msg) == 'on' then "..
				"LVBM.AddOns["..string.format('%q', index).."].Options.Enabled = true; "..
				"LVBM.AddMsg('Boss mod enabled!', "..string.format('%q', value.Name).."); "..
			"elseif string.lower(msg) == 'off' then "..
				"LVBM.AddOns["..string.format('%q', index).."].Options.Enabled = false; "..
				"LVBM.UnSchedule('LVBM.AddOns."..index..".OnEvent'); "..
				"LVBM.AddMsg('Boss mod disabled!', "..string.format('%q', value.Name).."); "..
			"elseif string.lower(msg) == 'announce on' then "..
				"LVBM.AddOns["..string.format('%q', index).."].Options.Announce = true; "..
				"LVBM.AddMsg('Announce enabled!', "..string.format('%q', value.Name).."); "..
			"elseif string.lower(msg) == 'announce off' then "..
				"LVBM.AddOns["..string.format('%q', index).."].Options.Announce = false; "..
				"LVBM.AddMsg('Announce disabled!', "..string.format('%q', value.Name).."); "..
			"elseif string.lower(msg) == 'stop' then "..
				"LVBM.UnSchedule('LVBM.AddOns."..index..".OnEvent'); "..
				"LVBM.AddMsg('Timers stopped!', "..string.format('%q', value.Name).."); "..
			"else "..			
				"if type(LVBM.AddOns["..string.format('%q', index).."].OnSlashCommand) == 'function' then "..
					"if LVBM.AddOns["..string.format('%q', index).."].OnSlashCommand(msg) then "..
						"return;"..
					"end "..
				"end "..
			
				"LVBM.AddMsg('Boss mod v'..LVBM.AddOns["..string.format('%q', index).."].Version..' by '..LVBM.AddOns["..string.format('%q', index).."].Author, "..string.format('%q', value.Name).."); "..
				"LVBM.AddMsg('/'..string.gsub(LVBM.AddOns["..string.format('%q', index).."].Name, ' ', '')..' on/off', "..string.format('%q', value.Name).."); "..
				"LVBM.AddMsg('/'..string.gsub(LVBM.AddOns["..string.format('%q', index).."].Name, ' ', '')..' announce on/off', "..string.format('%q', value.Name).."); "..
				"LVBM.AddMsg('/'..string.gsub(LVBM.AddOns["..string.format('%q', index).."].Name, ' ', '')..' stop', "..string.format('%q', value.Name).."); "..
				"if type(LVBM.AddOns["..string.format('%q', index).."].SlashCmdHelpText) == 'table' then "..
					"for index, value in LVBM.AddOns["..string.format('%q', index).."].SlashCmdHelpText do "..
						"if type(value) == 'string' then "..
							"LVBM.AddMsg(value, "..string.format('%q', value.Name).."); "..
						"end "..
					"end "..
				"end "..
					
				"if type(LVBM.AddOns["..string.format('%q', index).."].Abbreviation1) == 'string' then "..
					"abbrString = '/'..LVBM.AddOns["..string.format('%q', index).."].Abbreviation1; "..
				"end "..
				"if type(LVBM.AddOns["..string.format('%q', index).."].Abbreviation2) == 'string' and (not type(LVBM.AddOns["..string.format('%q', index).."].Abbreviation3) == 'string') then "..
					"abbrString = abbrString..' or /'..LVBM.AddOns["..string.format('%q', index).."].Abbreviation2; "..
				"elseif type(LVBM.AddOns["..string.format('%q', index).."].Abbreviation3) == 'string' then "..
					"abbrString = abbrString..', /'..LVBM.AddOns["..string.format('%q', index).."].Abbreviation2..' or /'..LVBM.AddOns["..string.format('%q', index).."].Abbreviation3; "..
				"end "..
					
				"if abbrString ~= '' then "..
					"LVBM.AddMsg('You can use '..abbrString..' instead of /'..string.gsub(LVBM.AddOns["..string.format('%q', index).."].Name, ' ', ''), "..string.format('%q', value.Name).."); "..
				"end "..
			"end "..
		"end")();
			
--[[	if value.Options.Enabled then
			LVBM.AddMsg(value.Name.." v"..value.Version.." by "..value.Author.." loaded! ("..GREEN_FONT_COLOR_CODE.."enabled"..FONT_COLOR_CODE_CLOSE..")");
		else
			LVBM.AddMsg(value.Name.." v"..value.Version.." by "..value.Author.." loaded! ("..RED_FONT_COLOR_CODE.."disabled"..FONT_COLOR_CODE_CLOSE..")");
		end ]]-- onload spam sucks
		if not loadedAddOns[value.Instance] then
			loadedAddOns[value.Instance] = 1;
		else
			loadedAddOns[value.Instance] = loadedAddOns[value.Instance] + 1;
		end
		
		LVBM.AddOns[index].OnLoad();
		
		table.insert(LVBM.SortedAddOns, index);		
	end
	for index, value in loadedAddOns do
		LVBM.AddMsg(value.." "..index.." boss mods loaded.")
	end
	table.sort(LVBM.SortedAddOns, function(v1, v2) return LVBM.AddOns[v1].Sort < LVBM.AddOns[v2].Sort; end);
end


function LVBM.OnEvent(event, arg1)
	if (event == "VARIABLES_LOADED") then
		LVBM.OnVarsLoaded();
	elseif (event == "PLAYER_LEAVING_WORLD") then
		LVBM_SavedVars.LVBM = LVBM.Options; --save variables
		for index, value in LVBM.AddOns do
			LVBM_SavedVars.AddOns[index] = value.Options; --save AddOn variables
		end
	elseif (event == "CHAT_MSG_RAID") or (event == "CHAT_MSG_RAID_LEADER") then
		local channel;
		_, _, channel = string.find(gsub(arg1, "%%", "%%%%"), "^<CTMod> This is an automatic message sent by CT_RaidAssist. Channel changed to: (.+)$");
		if channel then
			for i = 1, GetNumRaidMembers() do
				local name, rank;
				name, rank = GetRaidRosterInfo(i);
				if name == arg2 then
					if rank >= 1 then
						break;
					else
						return;
					end
				end
			end
			LVBM.SetSyncChannel(channel, arg2)
		end
	elseif (event == "CHAT_MSG_CHANNEL") and (LVBM.Options.EnableSync) then
		if string.sub(arg1, 1, 9) == "LVBM NSP " and (string.lower(arg9) == string.lower(LVBM.Options.Channel)) and (GetNumRaidMembers() > 1) then			
			for i = 1, GetNumRaidMembers() do				
				if GetRaidRosterInfo(i) == arg2 then
					LVBM.OnSyncMessage(string.sub(arg1, 10), arg2, true);
					break;
				end
			end
		elseif (string.sub(arg1, 1, 5) == "LVBM ") and (string.lower(arg9) == string.lower(LVBM.Options.Channel)) and (GetNumRaidMembers() > 1) then
			for i = 1, GetNumRaidMembers() do
				if GetRaidRosterInfo(i) == arg2 then
					LVBM.OnSyncMessage(string.sub(arg1, 6), arg2);
					break;
				end
			end			
		end
	elseif (event == "CHAT_MSG_CHANNEL_NOTICE") and (string.lower(arg9) == string.lower(LVBM.Options.Channel)) and (GetNumRaidMembers() > 1) then
		if arg1 == "YOU_JOINED" then
			LVBM.AddSyncMessage("REQ VER", true);
		elseif arg1 == "YOU_LEFT" then
			LVBM.SyncInfo.Clients = {};
		end
	elseif (event == "CHAT_MSG_CHANNEL_LEAVE") and (string.lower(arg9) == string.lower(LVBM.Options.Channel)) and arg2 and (GetNumRaidMembers() > 1) then
		if LVBM.SyncInfo.Clients[arg2] then
			LVBM.SyncInfo.Clients[arg2] = nil;
		end
	elseif (event == "RAID_ROSTER_UPDATE") then
		if GetNumRaidMembers() > 1 then
			if LVBM.InRaid then
				return;
			else
				LVBM.InRaid = true;
				LVBM.AddSyncMessage("REQ VER", true);
			end
		else
			if LVBM.InRaid then
				LVBM.InRaid = false;
			end
		end
	end
	for index, value in LVBM.AddOns do
		if value.Options.Enabled and value.Events[event] then
			LVBM.AddOns[index].OnEvent(event, arg1); --pass event to the AddOn
		end
	end
end


function LVBM.OnUpdate(elapsed)
--	for index, value in LVBM.ScheduleData do            ---> "invalid key for next"
--	for index = 1, table.getn(LVBM.ScheduleData) do     ---> "attempt to index a nil value"
	for index = table.getn(LVBM.ScheduleData), 1, -1 do
		value = LVBM.ScheduleData[index];
		if LVBM.ScheduleData[index] then --to prevent an error, when a scheduled function tries to unschedule itself oO
			LVBM.ScheduleData[index].elapsed = LVBM.ScheduleData[index].elapsed + elapsed;
			if LVBM.ScheduleData[index].elapsed >= LVBM.ScheduleData[index].timer then
				if type(value.func) == "function" then
					value.func(value.argument1, value.argument2);
				elseif type(value.func) == "string" then
					LVBM.ScheduleData.func = function() end; --reuse a global variable :>
					LVBM.ScheduleData.func = loadstring(value.func.."(".."value.argument1, value.argument2"..")") --getglobal() does not work in table values...getglobal("LVBM.AddMsg")("test") --> attempt to call a nil value :(
					LVBM.ScheduleData.func();
				end
				table.remove(LVBM.ScheduleData, index);
			end
		end
	end
	
	for index, value in LVBM.TimerData do
		if not value.stopped then
			LVBM.TimerData[index].elapsed = LVBM.TimerData[index].elapsed + elapsed;
		end
	end
	
	for index, value in LVBM.SpamProtection do
		LVBM.SpamProtection[index] = LVBM.SpamProtection[index] - elapsed;
		if LVBM.SpamProtection[index] <= 0 then
			LVBM.SpamProtection[index] = nil;
		end
	end
	
	for index, value in LVBM.AddOns do --execute the OnUpdate functions of the addons
		if value.Options.Enabled and type(value.OnUpdate) == "function" then
			LVBM.AddOns[index].elapsed = LVBM.AddOns[index].elapsed + elapsed;
			if value.elapsed > value.UpdateInterval then
				LVBM.AddOns[index].OnUpdate(LVBM.AddOns[index].elapsed);
				LVBM.AddOns[index].elapsed = 0;
			end
		end
	end
end



-------------------
--Timer Functions--
-------------------
function LVBM.Schedule(timer, func, argument1, argument2)
	if (type(timer) ~= "number") or (not func) then
		return;
	end
	
	table.insert(LVBM.ScheduleData, {
		["elapsed"] = 0,
		["timer"] = timer,
		["func"] = func,
		["argument1"] = argument1,
		["argument2"] = argument2,
	});	
end


function LVBM.UnSchedule(func, argument1, argument2)
	if not func then
		return;
	end
	
	if argument1 or argument2 then
--		for index, value in LVBM.ScheduleData do            ---> "invalid key for next"
--		for index = 1, table.getn(LVBM.ScheduleData) do     ---> "attempt to index field '?' (a nil value)" o_O
		for index = table.getn(LVBM.ScheduleData), 1, -1 do
			value = LVBM.ScheduleData[index];
			if value and value.func == func and value.argument1 == argument1 and value.argument2 == argument2 then
				LVBM.ScheduleData[index] = nil;
			end
		end
	else
--		for index, value in LVBM.ScheduleData do            ---> "invalid key for next"
--		for index = 1, table.getn(LVBM.ScheduleData) do     ---> "attempt to index field '?' (a nil value)" o_O
		for index = table.getn(LVBM.ScheduleData), 1, -1 do
			value = LVBM.ScheduleData[index];
			if value then
				if value and value.func == func then
					LVBM.ScheduleData[index] = nil;
				end
			end
		end
	end	

end


function LVBM.GetScheduleTimeLeft(func, argument1, argument2)
	if not func then
		return;
	end
	
	for index, value in LVBM.ScheduleData do
		if type(value) == "table" then
			if value and value.func == func and value.argument1 == argument1 and value.argument2 == argument2 then
				return (value.timer - value.elapsed), value.elapsed;
			end
		end
	end
end

function LVBM.FunctionIsScheduled(func)
	if not func then
		return;
	end
	
	for index, value in LVBM.ScheduleData do
		if type(value) == "table" then
			if value and value.func == func then
				return true;
			end
		end
	end
	return false;
end

function LVBM.StartTimer(name)
	if not name then
		return;
	end
	
	LVBM.TimerData[name] = {
		["elapsed"] = 0,
		["stopped"] = false,
	};	
end


function LVBM.GetTimer(name)
	if (not name) or (not LVBM.TimerData[name]) then
		return 0;
	end
	
	return LVBM.TimerData[name].elapsed;
end


function LVBM.StopTimer(name)
	if (not name) or (not LVBM.TimerData[name]) then
		return 0;
	end
	
	LVBM.TimerData[name].stopped = true;
	return LVBM.TimerData[name].elapsed;
end


function LVBM.ResumeTimer(name)
	if (not name) or (not LVBM.TimerData[name]) then
		return 0;
	end
	
	LVBM.TimerData[name].stopped = false;
	return LVBM.TimerData[name].elapsed;
end


function LVBM.EndTimer(name)
	if (not name) or (not LVBM.TimerData[name]) then
		return 0;
	end
	
	local elapsed = LVBM.TimerData[name].elapsed;
	LVBM.TimerData[name] = nil;
	return elapsed;
end


function LVBM.StartStatusBarTimer(timer, name, noBroadcast, syncedBy)
	if (type(timer) ~= "number") or (not name) or (name == "") then
		return;
	end	
	name = tostring(name);
	if type(syncedBy) ~= "string" then
		syncedBy = "local";
	end

	if syncedBy ~= "local" and ((LVBM.SyncInfo.Clients[syncedBy] and tonumber(LVBM.SyncInfo.Clients[syncedBy]) < 1.00) or (not LVBM.SyncInfo.Clients[syncedBy])) then
		return;
	end
	
	local barId;	
	if LVBM.StatusBarData[name] then
		barId = LVBM.StatusBarData[name].barId;
	else
		for i=1, 10 do
			if not getglobal("LVBM_StatusBarTimer"..i).isUsed then
				barId = i;
				break;
			end
		end	
		if not barId then
			return;
		end
	end	

	getglobal("LVBM_StatusBarTimer"..barId).isUsed = true;
	getglobal("LVBM_StatusBarTimer"..barId).usedBy = name;
	getglobal("LVBM_StatusBarTimer"..barId):SetMinMaxValues(0, timer);
	getglobal("LVBM_StatusBarTimer"..barId.."Text"):SetText(name);
	getglobal("LVBM_StatusBarTimer"..barId.."Timer"):SetText(LVBM.SecondsToTime(timer));
	getglobal("LVBM_StatusBarTimer"..barId):Show();
	
	LVBM.StatusBarData[name] = {
		["elapsed"] = 0,
		["timer"] = timer,
		["barId"] = barId,
		["syncedBy"] = syncedBy,
	};
	
	if not noBroadcast then
		LVBM.AddSyncMessage("ST SBT "..timer.." "..name);
	end	
end


function LVBM.GetStatusBarTimerTimeLeft(name)
	if (not name) or (not LVBM.StatusBarData[name]) then
		return false;
	end
	
	return (LVBM.StatusBarData[name].timer - LVBM.StatusBarData[name].elapsed), LVBM.StatusBarData[name].elapsed, LVBM.StatusBarData[name].syncedBy;
end


function LVBM.EndStatusBarTimer(name, noBroadcast, syncedBy)
	if (not name) or (not LVBM.StatusBarData[name]) then
		return;
	end
	
	if syncedBy and ((LVBM.SyncInfo.Clients[syncedBy] and tonumber(LVBM.SyncInfo.Clients[syncedBy]) < 1.00) or (not LVBM.SyncInfo.Clients[syncedBy])) then --old versions synced wrong timers :'(
		return;
	end
	
	local timeLeft, elapsed = LVBM.GetStatusBarTimerTimeLeft(name);
	if syncedBy and elapsed < 3 then --don't stop new timers on sync!
		return;
	end

	getglobal("LVBM_StatusBarTimer"..LVBM.StatusBarData[name].barId):Hide();	
	getglobal("LVBM_StatusBarTimer"..LVBM.StatusBarData[name].barId).isUsed = false;
	getglobal("LVBM_StatusBarTimer"..LVBM.StatusBarData[name].barId).usedBy = "";
--	getglobal("LVBM_StatusBarTimer"..LVBM.StatusBarData[name].barId.."Text"):SetText("StatusBarTimer"..LVBM.StatusBarData[name].barId);
--	getglobal("LVBM_StatusBarTimer"..LVBM.StatusBarData[name].barId.."Timer"):SetText("0.00");
	
	LVBM.StatusBarData[name] = nil;
	
	if not noBroadcast then
		LVBM.AddSyncMessage("END SBT 0 "..name)
	end
	
	LVBMStatusBars_PullTogether();
end

function LVBM.SecondsToTime(seconds)
	if type(seconds) ~= "number" then
		return "0.00";
	end
	local time = "";		

	if seconds > 60 then
		seconds = floor(seconds);
		time = (floor(seconds / 60))..":";
		seconds = mod(seconds, 60);
		if (string.len(seconds) == 1) then
			seconds = "0"..seconds;
		end
		time = time..seconds;
	elseif seconds >= 10 then
		time = string.sub(seconds, 1, 4);
	else
		time = string.sub(seconds, 1, 3);
	end

	return time;
end



---------------------
--Message Functions--
---------------------
function LVBM.Announce(Warning)
	local promoted = false;
	local addon = "";	

	_, _, addon = string.find(debugstack(2, 2, 2), "Boss_Mods\\%w+\\(%w+).lua");  -- =[
	if type(addon) == "string" then
		addon = string.gsub(addon, "LV", "");
	else
		_, _, addon = string.find(debugstack(2, 2, 2), "Boss_Mods\\%w+\\%w+\\(%w+).lua")
		if type(addon) == "string" then
			addon = string.gsub(addon, "LV", "");
		else
			addon = "";
		end
	end

	for i = 1, GetNumRaidMembers() do
		local name, rank;
		name, rank = GetRaidRosterInfo(i);
		if name == UnitName("player") and rank >= 1 then
			promoted = true;
		end
	end
	
	if ((not LVBM.AddOns[addon]) or LVBM.AddOns[addon].Options.Announce) and promoted then
		SendChatMessage(Warning, "RAID_WARNING");		
	else
		PlaySound("RaidWarning");
	end
	
	LVBMWarningFrame:AddMessage(Warning);
end


function LVBM.AddMsg(msg, addon)
	if (DEFAULT_CHAT_FRAME) then
		if type(addon) ~= "string" then			
			_, _, addon = string.find(debugstack(2, 2, 2), "Boss_Mods\\%w+\\(%w+).lua");
			if type(addon) == "string" then
				addon = string.gsub(addon, "LV", "");
			else
				_, _, addon = string.find(debugstack(2, 2, 2), "Boss_Mods\\%w+\\%w+\\(%w+).lua")
				if type(addon) == "string" then
					addon = string.gsub(addon, "LV", "");
				else
					addon = "LV Boss Mods";
				end
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage("["..addon.."]: "..tostring(msg), 0.0, 0.8, 0.0, 0.3);
	end	
end



-----------------------------
--Synchronization Functions--
-----------------------------
function LVBM.SetSyncChannel(channel, who)
	if type(channel) ~= "string" then
		return;
	end
	if type(who) == "string" then
		LVBM.AddMsg(who.." set the sync channel to: "..channel);
	else
		LVBM.AddMsg("Sync channel set to: "..channel);
	end
	
	if channel == LVBM.Options.Channel then
		return;
	end	
	
	if (not CT_RA_UpdateFrame) or (not CT_RA_UpdateFrame.newchan) then --we only need to this if ctraid is not already joining the new channel		
		if type(LVBM.Options.Channel) == "string" and (GetChannelName(LVBM.Options.Channel) ~= 0) then
			LeaveChannelByName(LVBM.Options.Channel);
		end
		
		LVBM.Schedule(1, "LVBM.JoinSyncChannel", channel) --we need to delay the join
	else
		LVBM.Options.Channel = channel;
		if CT_RA_Channel then
			CT_RA_Channel = channel;
		end
	end
end

function LVBM.JoinSyncChannel(channel)
	if type(channel) ~= "string" then
		return;
	end	
	LVBM.Options.Channel = channel;
	if CT_RA_Channel then
		CT_RA_Channel = channel;
	end	
	if GetChannelName(channel) == 0 then --this is a part of ctraids function CT_RA_Join
		channel = string.gsub(channel, "[^%w]", "");
		local name = channel;
		local zoneChannel, channelName = JoinChannelByName(name, nil, DEFAULT_CHAT_FRAME:GetID());
		if (channelName) then
			name = channelName;
		end
		if (not zoneChannel) then
			return;
		end
		
		local i = 1;

		while (DEFAULT_CHAT_FRAME.channelList[i]) do
			i = i + 1;
		end
		DEFAULT_CHAT_FRAME.channelList[i] = name;
		DEFAULT_CHAT_FRAME.zoneChannelList[i] = zoneChannel;
	end
end

function LVBM.BroadcastSyncChannel(channel)
	if (not (GetNumRaidMembers() > 1)) then
		return;
	end
	if type(channel) ~= "string" then
		channel = LVBM.Options.Channel
	end
	if type(channel) ~= "string" then
		LVBM.AddMsg("Channel not set. Cannot broadcast.");
		return;
	end
	
	for i = 1, GetNumRaidMembers() do
		local name, rank;
		name, rank = GetRaidRosterInfo(i);
		if (name == UnitName("player")) and (rank >= 1) then
			SendChatMessage("<CTMod> This is an automatic message sent by CT_RaidAssist. Channel changed to: "..channel, "RAID");
			return;
		end
	end
	LVBM.AddMsg("You need to be promoted or leader to broadcast the channel!");
end

function LVBM.AddSyncMessage(msg, noSpamProt)
	if not LVBM.Options.EnableSync then
		return;
	end
	if type(msg) == "string" and LVBM.Options.Channel and GetChannelName(LVBM.Options.Channel) ~= 0 and (not LVBM.SpamProtection[msg]) then		
		if noSpamProt then			
			SendChatMessage("LVBM NSP "..msg, "Channel", nil, GetChannelName(LVBM.Options.Channel));
		else
			SendChatMessage("LVBM "..msg, "Channel", nil, GetChannelName(LVBM.Options.Channel));
			LVBM.SpamProtection[msg] = 1.5;
		end
	end
end

function LVBM.OnSyncMessage(msg, player, noSpamProt)
	if not LVBM.Options.EnableSync then
		return;
	end
	if type(msg) == "string" and msg ~= "" and msg ~= " " and (not LVBM.SpamProtection[msg]) then		
		if not noSpamProt then
			LVBM.SpamProtection[msg] = 1.5;
		end	
		
		local name;
		local args = {};
		for value in string.gfind(msg, "([^%s]+)") do
			table.insert(args, value);
		end
		
		if not LVBM.SyncInfo.Clients[player] then
			LVBM.SyncInfo.Clients[player] = "0.94";
		end
		
		if args[1] == "ST" then
			_, _, _, _, _, name = string.find(msg, "([^%s]+) ([^%s]+) ([%d%.]+) (.*)");
			if args[2] == "SBT" and tonumber(args[3]) and name and ((not LVBM.GetStatusBarTimerTimeLeft(name)) or LVBM.GetStatusBarTimerTimeLeft(name) < 7.5) then
				LVBM.StartStatusBarTimer(tonumber(args[3]), name, true, player);
			end
		elseif args[1] == "END" then
			_, _, _, _, _, name = string.find(msg, "([^%s]+) ([^%s]+) ([%d%.]+) (.*)");
			if args[2] == "SBT" and name and LVBM.GetStatusBarTimerTimeLeft(name) then
				LVBM.EndStatusBarTimer(name, true, player);
			end
		elseif args[1] == "REQ" then
			if args[2] == "VER" then
				LVBM.AddSyncMessage("VER "..LVBM.Version, true);				
			end
		elseif args[1] == "VER" and tonumber(args[2]) then
			LVBM.SyncInfo.Clients[player] = args[2];
			if tonumber(args[2]) > tonumber(LVBM.Version) then
				local player1, player2;
				player1 = player;
				for index, value in LVBM.SyncInfo.Clients do
					if (value == args[2]) and (index ~= player1) then
						player2 = index;
						break;
					end
				end
				if player1 and player2 and (not LVBM.UpdateDialogShown) then
					LVBM.UpdateDialogShown = true;
					LVBMUpdateDialogText:SetText("Your version of La Vendetta Boss Mods is out of date!\n"..player1.." and "..player2.." got version "..args[2]..".\nPlease visit www.curse-gaming.com to get the latest version.");
					LVBMUpdateDialog:Show();
				end
			end
		end
	end
end

---------------------------------
--Register/Unregister Functions--
---------------------------------
function LVBM.Register()
	for index, value in LVBM.AddOns do
		for index2, value2 in value.Events do
			LVBM_API:RegisterEvent(index2);
		end
	end	
end

function LVBM.Unregister()
	LVBM_API:UnregisterAllEvents();
end

---------
--Hooks--
---------
LVBM.Hooks.oldChatFrame_OnEvent = ChatFrame_OnEvent;
function LVBM.Hooks.newChatFrame_OnEvent(event)
	if (event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER") and string.find(gsub(arg1, "%%", "%%%%"), "^<CTMod> This is an automatic message sent by CT_RaidAssist. Channel changed to: (.+)$") then
		return;
	elseif string.sub(event, 1, 16) == "CHAT_MSG_CHANNEL" and arg9 and arg9 == LVBM.Options.Channel then
		return;
	else
		LVBM.Hooks.oldChatFrame_OnEvent(event);
	end
end
ChatFrame_OnEvent = LVBM.Hooks.newChatFrame_OnEvent;