function LVBMStatusBars_SetDefaultValues()
	LVBM.Options.StatusBarColor = {
		["r"] = 1.0,
		["g"] = 0.7,
		["b"] = 0.0,
		["a"] = 1.0,
	};
	LVBM.Options.StatusBarsFlippedOver = false;
	LVBM.Options.FillUpStatusBars = true;
	LVBM.Options.EnableStatusBars = true;
end

function LVBMStatusBars_FlipOver()
	if LVBM.Options.StatusBarsFlippedOver then
		for i = 2, 10 do
			getglobal("LVBM_StatusBarTimer"..i):ClearAllPoints()
			getglobal("LVBM_StatusBarTimer"..i):SetPoint("BOTTOM", "LVBM_StatusBarTimer"..(i-1), "TOP", 0, 4);
		end
	else
		for i = 2, 10 do
			getglobal("LVBM_StatusBarTimer"..i):ClearAllPoints()
			getglobal("LVBM_StatusBarTimer"..i):SetPoint("TOP", "LVBM_StatusBarTimer"..(i-1), "BOTTOM", 0, -4);
		end
	end
end

function LVBMStatusBars_PullTogether()
	for i = 2, 10 do
		if getglobal("LVBM_StatusBarTimer"..i).isUsed and (not getglobal("LVBM_StatusBarTimer"..(i-1)).isUsed) then
			local j = i - 1;
			local barName = getglobal("LVBM_StatusBarTimer"..i.."Text"):GetText();
			local timer = LVBM.StatusBarData[barName].timer;
			local elapsed = LVBM.StatusBarData[barName].elapsed;
			local syncedBy = LVBM.StatusBarData[barName].syncedBy;
			getglobal("LVBM_StatusBarTimer"..i):Hide();	
			getglobal("LVBM_StatusBarTimer"..i).isUsed = false;
			getglobal("LVBM_StatusBarTimer"..i).usedBy = "";
			LVBM.StatusBarData[barName] = nil;
			
			getglobal("LVBM_StatusBarTimer"..j).isUsed = true;
			getglobal("LVBM_StatusBarTimer"..j).usedBy = barName;
			getglobal("LVBM_StatusBarTimer"..j):SetMinMaxValues(0, timer);
			getglobal("LVBM_StatusBarTimer"..j.."Text"):SetText(barName);
			getglobal("LVBM_StatusBarTimer"..j.."Timer"):SetText(LVBM.SecondsToTime(timer));
			getglobal("LVBM_StatusBarTimer"..j):Show();
	
			LVBM.StatusBarData[barName] = {
				["elapsed"] = elapsed,
				["timer"] = timer,
				["barId"] = j,
				["syncedBy"] = syncedBy,
			};

		end
	end
end