LVBM.AddOns.Grobbulus = {
	["Name"] = "Grobbulus",
	["Abbreviation1"] = "grob",
	["Abbreviation2"] = "grobb",
	["Version"] = "1.2",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Sets raid target icon (skull) on players that are afflicted by Mutating Injection.",
	["Instance"] = "Naxxramas",
	["Sort"] = 42,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
		["Whisper"] = false,
	},
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.Grobbulus.Options.Whisper",
			["text"] = "Send Whisper",
			["func"] = function() LVBM.AddOns.Grobbulus.Options.Whisper = not LVBM.AddOns.Grobbulus.Options.Whisper; end,
		},
	},
	["Events"] = {
		["CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"] = true,
		["CHAT_MSG_SPELL_AURA_GONE_OTHER"] = true,
		["CHAT_MSG_SPELL_AURA_GONE_SELF"] = true,
	},
	["OnEvent"] = function(event, arg1) 
		if (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") or (event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE") or (event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE") then
			local Name, Type;
			_, _, Name, Type = string.find(arg1, "^([^%s]+) ([^%s]+) afflicted by Mutating Injection");
			if (Name == "You") and (Type == "are") then
				Name = UnitName("player");
			end
			if Name then
				local targetID, promoted;
				for i = 1, GetNumRaidMembers() do
					if UnitName("raid"..i) == UnitName("player") then
						_, promoted = GetRaidRosterInfo(i);
					end
					if UnitName("raid"..i) == Name then
						targetID = i;
					end
				end
				if targetID and promoted >= 1 then
					if GetRaidTargetIndex("raid"..targetID) ~= 8 then
						SetRaidTargetIcon("raid"..targetID, 8);
					end
				end	

				if LVBM.AddOns.Grobbulus.Options.Whisper and Name ~= UnitName("player") then
					SendChatMessage("You are injected!", "WHISPER", this.language, Name);
				end
				LVBM.Announce("*** "..Name.." is injected ***");
			end
		elseif ((event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") or (event == "CHAT_MSG_SPELL_AURA_GONE_SELF")) and arg1 then
			local Name;
			_, _, Name = string.find(arg1, "Mutating Injection fades from (%w+)");
			if Name then
				local targetID, promoted;
				for i = 1, GetNumRaidMembers() do
					if UnitName("raid"..i) == UnitName("player") then
						_, promoted = GetRaidRosterInfo(i);
					end
					if UnitName("raid"..i) == Name then
						targetID = i;
					end
				end	
				if targetID and promoted >= 1 then
					if GetRaidTargetIndex("raid"..targetID) == 8 then
						SetRaidTargetIcon("raid"..targetID, 0);
					end
				end	
			end
		end
	end,
};