--
-- La Vendetta Noth the Plaguebringer Raid Warning AddOn
-- (c) by Nitram from La Vendetta on DE-Azshara
--

if (GetLocale() == "enGB") or (GetLocale() == "enUS") then
	NTP_SPELL_1 = "Noth the Plaguebringer gains Blink";		-- Each time he Blinks 
	NTP_YELL_START1 = "Die, trespasser!";					-- Combat Starts
	NTP_YELL_START2 = "Glory to the master!";				-- Combat Starts
	NTP_YELL_START3 = "Your life is forfeit!";				-- Combat Starts
else
	NTP_SPELL_1 = "Noth the Plaguebringer gains Blink";		-- Each time he Blinks 
	NTP_YELL_START1 = "Die, trespasser!";					-- Combat Starts
	NTP_YELL_START2 = "Glory to the master!";				-- Combat Starts
	NTP_YELL_START3 = "Your life is forfeit!";				-- Combat Starts
end

LVBM.AddOns.Noth = {
	["Name"] = "Noth the Plaguebringer",
	["Abbreviation1"] = "Noth",
	["Abbreviation2"] = "NTP",
	["Version"] = "1.5",
	["Author"] = "Nitram",
	["Description"] = "Provides timers for Noth's Teleport and Blink.",
	["Instance"] = "Naxxramas",
	["Sort"] = 31,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
		["TimeOnBalcony"] = 70;
		["TimeInRoom"] = 90;
		["OnBalcony"] = false,
	},
	["Events"] = {
		["CHAT_MSG_MONSTER_YELL"] = true,
		["CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS"] = true, 
	},
	["OnSlashCommand"] = function(msg)
		if (string.lower(msg) == "stop") then
			LVBM.AddOns.Noth.Options.TimeOnBalcony = 70;
			LVBM.AddOns.Noth.Options.TimeInRoom = 90;
			LVBM.AddOns.Noth.Options.OnBalcony = false;	
		end
	end,
	["OnEvent"] = function(event, arg1, arg2)
		if ((event == "CHAT_MSG_MONSTER_YELL" and (string.find(arg1, NTP_YELL_START1) or string.find(arg1, NTP_YELL_START2) or string.find(arg1, NTP_YELL_START3))) or event == "LVBM.BACKINROOM") then
			LVBM.AddOns.Noth.InCombat = true;
			LVBM.AddOns.Noth.Options.OnBalcony = false;					
			if (event == "LVBM.BACKINROOM") then
				LVBM.Announce("*** Noth is back ("..LVBM.AddOns.Noth.Options.TimeInRoom.." sec) - fight him ***");	-- Callout Warning
			else
				LVBM.Announce("*** "..LVBM.AddOns.Noth.Options.TimeInRoom.." sec until teleport - fight him ***");	-- Callout Warning
				LVBM.AddOns.Noth.Options.TimeOnBalcony = 70;
				LVBM.AddOns.Noth.Options.TimeInRoom = 90;
			end
			LVBM.Schedule((LVBM.AddOns.Noth.Options.TimeInRoom-10), "LVBM.AddOns.Noth.OnEvent", "NTP10SecWarningTeleport");
			LVBM.Schedule(LVBM.AddOns.Noth.Options.TimeInRoom, "LVBM.AddOns.Noth.OnEvent", "NTPGoToBalcony");
			LVBM.StartStatusBarTimer(LVBM.AddOns.Noth.Options.TimeInRoom, "Teleport to Balcony");
		end
	
		if( event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS" ) then			
			if (string.find(arg1, NTP_SPELL_1)) then
				LVBM.AddOns.Noth.InCombat = true;
				LVBM.Announce("*** Noth gains Blink - STOP DMG ***");		-- Callout Warning
				LVBM.Schedule(25, "LVBM.AddOns.Noth.OnEvent", "NTP5SecWarningBlink");
				LVBM.StartStatusBarTimer(30, "Blink");
				LVBM.UnSchedule("LVBM.AddOns.Noth.OnEvent", "NTP10SECUNTILBACK");			-- He only Gains blink
				LVBM.UnSchedule("LVBM.AddOns.Noth.OnEvent", "LVBM.BACKINROOM");				-- if he is in the room
				if (LVBM.AddOns.Noth.Options.OnBalcony) then
					LVBM.AddOns.Noth.OnEvent("LVBM.BACKINROOM");
				end
			end
		end
			
		if (event == "NTP5SecWarningBlink") then							-- Blink System
			LVBM.Announce("*** Blink in ~5 sec ***");
				
		elseif (event == "NTP10SecWarningTeleport") then
			LVBM.Announce("*** Teleport in 10 Sec ***");
				
		elseif (event == "NTP10SECUNTILBACK" ) then
			LVBM.Announce("*** 10 Sec until he comes back ***");
			
		elseif (event == "NTPGoToBalcony" ) then
			LVBM.AddOns.Noth.Options.OnBalcony = true;
			LVBM.Schedule((LVBM.AddOns.Noth.Options.TimeOnBalcony-10), "LVBM.AddOns.Noth.OnEvent", "NTP10SECUNTILBACK");
			LVBM.Schedule(LVBM.AddOns.Noth.Options.TimeOnBalcony, "LVBM.AddOns.Noth.OnEvent", "LVBM.BACKINROOM");
			LVBM.StartStatusBarTimer(LVBM.AddOns.Noth.Options.TimeOnBalcony, "Teleport back");
			if (LVBM.AddOns.Noth.Options.TimeOnBalcony == 70 ) then
				LVBM.AddOns.Noth.Options.TimeOnBalcony = 95;
				LVBM.AddOns.Noth.Options.TimeInRoom = 110;
			elseif (LVBM.AddOns.Noth.Options.TimeOnBalcony == 95) then
				LVBM.AddOns.Noth.Options.TimeOnBalcony = 120;
				LVBM.AddOns.Noth.Options.TimeInRoom = 180;
			end
	
			LVBM.UnSchedule("LVBM.AddOns.Noth.OnEvent", "NTP5SecWarningBlink");
		elseif (event == "ConfirmCombatEnd") then
			if (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) then			
				LVBM.UnSchedule("LVBM.AddOns.Noth.OnEvent");
				LVBM.EndStatusBarTimer("Teleport back", true);
				LVBM.EndStatusBarTimer("Teleport to Balcony", true);
				LVBM.EndStatusBarTimer("Blink", true);
				LVBM.AddOns.Noth.InCombat = false;
			end
		end
	end,
	
	["OnUpdate"] = function(elapsed) 
		if (LVBM.AddOns.Noth.InCombat) and (not UnitAffectingCombat("player")) and (not UnitIsDeadOrGhost("player")) and (not LVBM.GetScheduleTimeLeft("LVBM.AddOns.Noth.OnEvent", "ConfirmCombatEnd")) then
			LVBM.Schedule(10, "LVBM.AddOns.Noth.OnEvent", "ConfirmCombatEnd");
		end
	end,
	["UpdateInterval"] = 3,
}
