--La Vendetta Anub'Rekhan Raid Warning AddOn

if (GetLocale() == "enGB") or (GetLocale() == "enUS") then
	AR_YELL_1 = "There is no way out.";
	AR_YELL_2 = "Just a little taste...";	
	AR_YELL_3 = "Yes, run! It makes the blood pump faster!";
	AR_GAIN_LOCUST_SWARM = "Anub'Rekhan gains Locust Swarm.";
	AR_CAST_LOCUST_SWARM = "Anub'Rekhan begins to cast Locust Swarm.";
elseif (GetLocale() == "deDE") then --localization by DoctorVanGogh
	AR_YELL_1 = "Es gibt kein Entkommen."; 
	AR_YELL_2 = "Nur einmal kosten..."; 
	AR_YELL_3 = "Rennt! Das bringt das Blut in Wallung!"; 
	AR_GAIN_LOCUST_SWARM = "Anub'Rekhan bekommt 'Heuschreckenschwarm'."; 
	AR_CAST_LOCUST_SWARM = "Anub'Rekhan beginnt Heuschreckenschwarm zu wirken."; 
end

LVBM.AddOns.AnubRekhan = {
	["Name"] = "Anub'Rekhan",
	["Abbreviation1"] = "Anub",
	["Abbreviation2"] = "ar",
	["Abbreviation3"] = "AnubRekhan",
	["Version"] = "1.7",
	["Author"] = "La Vendetta|Tandanu",
	["Description"] = "Provides a timer for Anub'Rekhan's Locust Swarm.",
	["Instance"] = "Naxxramas",
	["Sort"] = 11,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
	},
	["Events"] = {
		["CHAT_MSG_MONSTER_YELL"] = true,
		["CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS"] = true,
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF"] = true,
	},	
	["OnEvent"] = function(event, arg1)
		if (event == "CHAT_MSG_MONSTER_YELL") then
			if (arg1 == AR_YELL_1) or (arg1 == AR_YELL_2) or (arg1 == AR_YELL_3) then
				LVBM.Announce("*** Locust Swarm in ~90 sec ***");
				LVBM.StartStatusBarTimer(90, "Locust Swarm");
				LVBM.Schedule(30, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustWarning", 60);
				LVBM.Schedule(60, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustWarning", 30);
				LVBM.Schedule(75, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustWarning", 15);
				LVBM.Schedule(85, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustWarning", 5);
			end
		elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF") then
			if (arg1 == AR_CAST_LOCUST_SWARM) then
				LVBM.Announce("*** Locust Swarm inc - 3 sec ***");
				LVBM.EndStatusBarTimer("Locust Swarm");
				LVBM.StartStatusBarTimer(3, "Locust Swarm Cast");
				LVBM.Schedule(23, "LVBM.AddOns.AnubRekhan.OnEvent", "StartNewLocustTimer");
			end
		elseif (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS") then
			if (arg1 == AR_GAIN_LOCUST_SWARM) then
				LVBM.Announce("*** Locust Swarm now - 20 sec ***", "RAID_WARNING");
				LVBM.EndStatusBarTimer("Locust Swarm Cast", true);
				LVBM.StartStatusBarTimer(20, "Locust Swarm");
				LVBM.Schedule(10, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustEndWarning", 10);
				LVBM.Schedule(17, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustEndWarning", 3);
			end
		elseif (event == "LocustWarning") then
			if arg1 == 60 then
				LVBM.Announce("*** Locust Swarm in ~60 sec ***");
			elseif arg1 == 30 then
				LVBM.Announce("*** Locust Swarm in ~30 sec ***");
			elseif arg1 == 15 then			
				LVBM.Announce("*** Locust Swarm in ~15 sec ***");
			elseif arg1 == 5 then
				LVBM.Announce("*** Locust Swarm in ~5 sec ***");
			end			
		elseif (event == "LocustEndWarning") then
			if arg1 == 10 then
				LVBM.Announce("*** Locust Swarm ends in 10 sec ***");
			elseif arg1 == 3 then
				LVBM.Announce("*** Locust Swarm ends in 3 sec ***");			
			end
		elseif (event == "StartNewLocustTimer") then
			LVBM.Announce("*** Locust Swarm in ~70 sec ***");
			LVBM.StartStatusBarTimer(70, "Locust Swarm");
			LVBM.Schedule(40, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustWarning", 30);
			LVBM.Schedule(55, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustWarning", 15);
			LVBM.Schedule(65, "LVBM.AddOns.AnubRekhan.OnEvent", "LocustWarning", 5);
		end	
	end,
};