LVBM.AddOns.Maexxna = {
	["Name"] = "Maexxna",
	["Abbreviation1"] = "Maex",
	["Abbreviation2"] = "Maexx",
	["Abbreviation3"] = "Mae",
	["Version"] = "1.6",
	["Author"] = "Tandanu",
	["Description"] = "Provides timers for Maexxna's Web Spray and spider adds.",
	["Instance"] = "Naxxramas",
	["Sort"] = 13,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
		["Yell"] = true,
	},
	["isSpraying"] = false,
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.Maexxna.Options.Yell",
			["text"] = "Yell when web wrapped",
			["func"] = function() LVBM.AddOns.Maexxna.Options.Yell = not LVBM.AddOns.Grobbulus.Options.Yell; end,
		},
	},
	["Events"] = {
		["PLAYER_REGEN_DISABLED"] = true,
		["CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"] = true,
		["CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS"] = true,
		["CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"] = true,
		["CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"] = true,
		["CHAT_MSG_COMBAT_FRIENDLY_DEATH"] = true,
	},	
	
	["OnEvent"] = function(event, arg1)
		if event == "PLAYER_REGEN_DISABLED" and GetRealZoneText() == "Naxxramas" then
			if UnitClass("player") == LVBM_ROGUE or UnitClass("player") == LVBM_WARRIOR then
				return;
			end
				
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;  --to prevent unknown unit error
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Maexxna");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
				
			if UnitName("target") == "Maexxna" then
				LVBM.Schedule(2, "LVBM.AddOns.Maexxna.OnEvent", "ConfirmCombat");
			end
				
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "ConfirmCombat" then		
			if UnitClass("player") == "Rogue" then
				return;
			end
			local oldTarget;
			oldTarget = UnitName("target");
			oldUIErrorsFrame_OnEvent = UIErrorsFrame_OnEvent;  --to prevent unknown unit error
			UIErrorsFrame_OnEvent = function() end;
			TargetByName("Maexxna");
			UIErrorsFrame_OnEvent = oldUIErrorsFrame_OnEvent;
			
			if (UnitName("target")) == "Maexxna" and UnitAffectingCombat("target") then
				LVBM.Schedule(23, "LVBM.AddOns.Maexxna.OnEvent", "SprayWarning", 15);
				LVBM.Schedule(33, "LVBM.AddOns.Maexxna.OnEvent", "SprayWarning", 5);
				LVBM.Schedule(23, "LVBM.AddOns.Maexxna.OnEvent", "SpiderWarning", 5);
				LVBM.Schedule(28, "LVBM.AddOns.Maexxna.OnEvent", "SpiderWarning", 0);				
				LVBM.StartStatusBarTimer(38, "Web Spray");
				LVBM.StartStatusBarTimer(28, "Spider Spawn");
			end
			
			if UnitName("target") ~= oldTarget then
				TargetLastTarget();
			end
		elseif event == "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS" or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE" or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE" then
			if (string.find(arg1,"Web Spray") and (not LVBM.AddOns.Maexxna.isSpraying)) then			
				LVBM.Schedule(25, "LVBM.AddOns.Maexxna.OnEvent", "SprayWarning", 15);
				LVBM.Schedule(35, "LVBM.AddOns.Maexxna.OnEvent", "SprayWarning", 5);
				LVBM.Schedule(25, "LVBM.AddOns.Maexxna.OnEvent", "SpiderWarning", 5);
				LVBM.Schedule(30, "LVBM.AddOns.Maexxna.OnEvent", "SpiderWarning", 0);
				LVBM.StartStatusBarTimer(40, "Web Spray");
				LVBM.StartStatusBarTimer(30, "Spider Spawn");
				
				LVBM.AddOns.Maexxna.isSpraying = true;
				LVBM.Schedule(10, "LVBM.AddOns.Maexxna.OnEvent", "ResetIsSpraying"); 
			end
         
			local _, _, playerName, playerType = string.find(arg1, "^([^%s]+) ([^%s]+) afflicted by Web Wrap%.$");
			if playerName == "You" then
				playerName = UnitName("player");
				if LVBM.AddOns.Maexxna.Options.Yell then
					for i = 1, GetNumRaidMembers() do
						local name, rank, subgroup;
						name, rank, subgroup = GetRaidRosterInfo(i)
						if name == UnitName("player") then
							SendChatMessage(name.. " is web wrapped. Group "..subgroup..".", "YELL");
							break;
						end
					end
				end
			end
			if (playerName) then
				LVBM.Announce("*** "..tostring(playerName).." is wrapped ***");
			end		
		elseif event == "ResetIsSpraying"  then
			LVBM.AddOns.Maexxna.isSpraying = false;			
		elseif event == "SprayWarning" then
			if arg1 == 15 then
				LVBM.Announce("*** Web Spray in 15 sec ***");
			elseif arg1 == 5 then
				LVBM.Announce("*** Web Spray in 5 sec ***");
			end
		elseif event == "SpiderWarning" then
			if arg1 == 5 then
				LVBM.Announce("*** Spiders in 5 sec ***");
			elseif arg1 == 0 then
				LVBM.Announce("*** Spiders spawned ***");
			end
		end      
   end,   
};
